%global reltag Final

Name:           wise
Version:        2.0.3
Release:        7%{?dist}
Summary:        JBoss Wise: 'Wise invokes services easily'

License:        LGPLv2+ and ASL 2.0
URL:            http://www.jboss.org/%{name}
Source0:        http://download.jboss.org/%{name}/%{name}-distribution-%{version}.%{reltag}.zip
Source1:        http://www.apache.org/licenses/LICENSE-2.0.txt

# Implement abstract method setClientJar from superclass in F20+
Patch0:         %{name}-CXFConsumerImpl.patch

Patch1:         %{name}-javadoc.patch

BuildArch: noarch

BuildRequires: maven-local
BuildRequires: mvn(wsdl4j:wsdl4j)
BuildRequires: mvn(org.milyn:milyn-commons)
BuildRequires: mvn(org.jboss.ws:jbossws-spi)
BuildRequires: mvn(net.jcip:jcip-annotations)
BuildRequires: mvn(org.jboss.ws:jbossws-parent:pom:)
BuildRequires: mvn(org.jboss.ws:jbossws-common)
BuildRequires: mvn(org.jboss.logging:jboss-logging)
BuildRequires: mvn(org.jboss.ws:jbossws-common-tools)
BuildRequires: mvn(org.milyn:milyn-smooks-validation)
BuildRequires: mvn(org.jboss.ws.cxf:jbossws-cxf-client)

%description
Wise is a Java framework for easily invoking webservices, which can be used as
base for zero-code webservice invocation applications. Wise can be the proper
solution when total and effective client/server decoupling through WS is
required.

While basic JAX-WS tool for wsdl-to-java generation (like wsconsume) are great
for most Java developer usecases, the generated stub classes kind of introduce
a new (or renewed :)) level of coupling very similar to Corba IDL; by
generating statical webservice stubs you actually couple client and server.

So what is the alternative? Writing dynamic client using dynamic
Provider/Dispatch JAX-WS API? That's possibly an option, yet not the easiest
to understand, implement and maintain in most enterprise environments. Wise
provides a different solution using dynamic mapping on JAX-WS tools generated
code. Wise allows calling a ws service by mapping a generic Object model to
JAXWS generated code. This opens up multiple Wise usage scenarios, like
zero-code WS invocation (used in JBoss ESB) or GUI driven WS invocation.

%package javadoc
Summary:        Javadoc for %{name}

%description javadoc
API documentation for %{name}.

%package core
Summary: JBoss Wise Core
Requires: %{name} = %{version}-%{release}

%description core
It is a library to simplify web service invocation from a client point of view:
it aims at providing a near zero-code solution to find and parse wsdls, select
service and endpoint and call operations mapping user defined object model to
JAX-WS objects required to perform the call.

%package core-cxf
Summary: JBoss Wise Core CXF
Requires: %{name} = %{version}-%{release}

%description core-cxf
%{summary}.

%prep
%setup -qn %{name}-%{version}.%{reltag}/src
cp %{SOURCE1} .

find ../ -name '*.class' -delete
find ../ -name '*.jar' -delete

%if 0%{?fedora} >= 20
%patch0
%endif

%patch1 -p1

%build
# Tests fail because of different hamcrest versions
%mvn_build -s --skip-tests

%install
%mvn_install

%files -f .mfiles-wise
%doc LICENSE-2.0.txt
%files javadoc -f .mfiles-javadoc
%files core -f .mfiles-%{name}-core
%files core-cxf -f .mfiles-%{name}-core-cxf

%changelog
* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.3-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sun Aug 16 2015 Gerard Ryan <galileo@fedoraproject.org> - 2.0.3-6
- RHBZ#1240055 FTBFS in rawhide

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Feb 25 2014 Gerard Ryan <galileo@fedoraproject.org> - 2.0.3-3
- RHBZ#1068592: Switch to java-headless requires

* Sat Aug 17 2013 Gerard Ryan <galileo@fedoraproject.org> - 2.0.3-2
- Add BR on mvn(org.jboss.ws:jbossws-common-tools)

* Mon Jul 29 2013 Gerard Ryan <galileo@fedoraproject.org> - 2.0.3-1
- Initial package.
